class LogMagic::MySqlExplainer::QueryExplainerSection
  include ::LogMagic::TemplatingUtils
  attr_reader :mysql_query

  def initialize(mysql_query)
    @mysql_query = mysql_query
  end

  def explanation
    rendered_template
  end

  def template_name
    'query.haml'
  end

  def explainer_section_classes
    [
      ::LogMagic::MySqlExplainer::IsNullExplainerSection,
      ::LogMagic::MySqlExplainer::OrderByExplainerSection,
      ::LogMagic::MySqlExplainer::WhereExplainerSection,
      ::LogMagic::MySqlExplainer::SelectExplainerSection
    ]
  end

  def enriche_mysql_query
    explainer_section_classes.map do |explainer_section_class|
      explainer_section_class.new(mysql_query)
    end.each do |explainer_section|
      explainer_section.enriche
    end
  end
end
