require 'rack'
require 'byebug'
require 'haml'

class LogMagic::MySqlExplainer < LogMagic::BaseExplainer
  def self.port_number
    7469
  end

  def mysql_query
    # TODO: find root issue for why chomping \e[0m is necessary
    mysql_query = @persistance_layer.retrieve_value(@uuid, 'mysql_query').chomp('[0m')
    mysql_query = mysql_query[0..-2]
    mysql_query
  end

  def explained_query
    @query_explainer = QueryExplainerSection.new(mysql_query)
    @query_explainer.enriche_mysql_query
    @query_explainer
  end

  def template_name
    'mysql.haml'
  end
end
