require 'hash_deep_search'

class LogMagic::SearchkickExplainer::CustomAnalyzerHover
  def initialize(query_explainer, index_settings)
    @query_explainer = query_explainer
    @index_settings = JSON.parse(index_settings)
  end

  def enriche
    @query_explainer.query_json.clone.scan(custom_analyzer_matcher) do |match|
      inject_hover(match[0])
    end
  end

  def inject_hover(match)
    @query_explainer.query_json.sub!(/[^w]#{match}[^w]/, hover_template(match).rendered_template)
  end

  def hover_template(match)
    ::LogMagic::HoverRenderer.new(match, HashDeepSearch.new(@index_settings).search(match))
  end

  def custom_analyzer_matcher
    /[^w]analyzer[^w]\n[^<]*<\/a>\n:&nbsp;"([^"]*)"/
  end
end
