class LogMagic::SearchkickExplainer::SettingsExplainerSection
  include ::LogMagic::TemplatingUtils
  include ::LogMagic::JSONUtils
  attr_reader :elasticsearch_url

  def initialize(elasticsearch_url, query_explainer)
    @query_explainer = query_explainer
    @elasticsearch_url = elasticsearch_url
    enriche_query_json
  end

  def index_settings
    @index_settings ||= `curl #{elasticsearch_url}/_settings`
  end

  def explanation
    rendered_template
  end

  def template_name
    'settings.haml'
  end

  def enriche_query_json
    explainer = ::LogMagic::SearchkickExplainer::CustomAnalyzerHover.new(@query_explainer, index_settings)
    explainer.enriche
  end
end
