require 'rack'
require 'byebug'
require 'haml'

class LogMagic::SearchkickExplainer < LogMagic::BaseExplainer
  def self.port_number
    7467
  end

  def query_json
    @persistance_layer.retrieve_value(@uuid, 'query_json')
  end

  def elasticsearch_url
    @persistance_layer.retrieve_value(@uuid, 'elasticsearch_url')
  end

  def settings_explainer_section
    SettingsExplainerSection.new(elasticsearch_url, @query_explainer)
  end

  def explained_query
    @query_explainer = QueryExplainerSection.new(query_json)
    settings_explainer_section.enriche_query_json
    @query_explainer
  end

  def template_name
    'searchkick.haml'
  end
end
