class LogMagic::MySqlRefiner < LogMagic::BaseRefiner
  def line_match_regex
    /\w*\sLoad/
  end

  def compute
    mysql_query = extract_mysql_query
    persist_mysql_query(mysql_query)
    output(mysql_query, persistance_layer.uuid)
  end

  def output(mysql_query, uuid)
    mysql_printer = ::LogMagic::MySqlPrinter.new(mysql_query, uuid)
    mysql_printer.print
  end

  def extract_mysql_query
    @lines.last.match(load_sql_regex)[1]
  end

  def persist_mysql_query(mysql_query)
    persistance_layer.add_value('mysql_query', mysql_query)
  end

  def load_sql_regex
    /Load \([\d\.]+ms\)[^S]*(.*)/
  end
end
