module LogMagic::TemplatingUtils
  def initialize(object_to_enriche)
    @object_to_enriche = object_to_enriche
  end

  def rendered_template
    engine = Haml::Engine.new(File.read(template_path))
    engine.render(self)
  end

  def template_path
    file_name = File.expand_path(
      file_name = File.join(__FILE__, '..', '..', template_dir, template_name)
    )
    fail("No template found for #{self.class.name}") unless File.exist?(file_name)
    return file_name
  end

  def enriche
    @object_to_enriche.gsub!(match_regex, rendered_template)
  end

  def match_regex
    /(?:[^\w]|\A)#{term_name}[^\w]/
  end

  def template_name
    "#{term_name}.haml"
  end

  def template_dir
    if self.class.name =~ /\w*::\w*::\w*/
      if self.class.name =~ /LogMagic::SearchkickExplainer/
        'explainer_templates/searchkick'
      elsif self.class.name =~ /LogMagic::MySqlExplainer/
        'explainer_templates/mysql'
      end
    else
      'explainer_templates'
    end
  end
end
